
{}
{							}
{	INPUTWIN  --field edit window			}
{       tvDMX     --data editing project (ver 2.x)      }
{							}
{       Copyright (c) 1992-96   Randolph Beck           }
{				P.O. Box  540433	}
{				Orlando, FL 32854	}
{							}
{	http://www.byronref.com/rmb/			}
{	email:  rb@randybeck.com			}
{                                                       }
{}

Unit INPUTWIN;

{$D+,B-,O+,R-,V-,X+ }

interface

uses
    Objects, Drivers, Dialogs, Views, App, MsgBox, RSet, DmxGizma, tvDMX;

type
    PEditField	= ^TEditField;
    TEditField	=  OBJECT(TInputLine)
	DMX : PDmxEditor;
      constructor Init(ADmx : PDmxEditor);
      function	Valid(Command : word) : boolean;  VIRTUAL;
    end;


    PFieldWin	= ^TFieldWin;
    TFieldWin	=  OBJECT(TDialog)
      constructor Init(ATitle : TTitleStr;  ADmx : PDmxEditor);
      procedure HandleEvent(var Event : TEvent);  VIRTUAL;
    end;


  procedure CalcVal(S : string;  var V : trealnum;  var code : integer);
  procedure CurrentFieldWindow;


implementation

var  t1	: integer;

  {  }


procedure CalcVal(S : string;  var V : trealnum;  var code : integer);
var  x,E   : integer;
     AbsOn : boolean;

    function  Compute(Num : trealnum; Func :boolean; iter :integer) : trealnum;
    var  Op  : char;
	 Ready,Quit : boolean;

	procedure Error(Err : word);
	begin
	  If (E = 0) then E := Err;
	  code := x;
	end;

	procedure DoCalc(N : trealnum);
	begin
	  Case Op of
	    '+':	Num := Num + N;
	    '-':	Num := Num - N;
	    '*':	Num := Num * N;
	    '/':	If (N = 0) then Error(5) else Num := Num / N;
	    '^':	Num := exp(Ln(abs(Num)) * abs(N));
	   else		Error(4);
	    end;
	  Op := #0;
	  If Func then Quit := TRUE;
	end;

	procedure CheckNext(var N : trealnum);
	var  i	: integer;
	     c	: char;
	begin
	  Repeat
	    i := x;
	    c := #0;
	    While (i < length(S)) and (c = #0) do
	      begin
	      If (S[i] in['+','-','*','/','^','%','|','(',')']) then c := S[i];
	      inc(i);
	      end;
	    If (c in['*','/','^','%']) then
	      N := Compute(N, TRUE, succ(iter));
	  Until not (c in['*','/','^','%']);
	end;

	procedure Punch(N : trealnum);
	begin
	  If (Op <> #0) then
	    begin
	    CheckNext(N);
	    DoCalc(N);
	    end
	   else
	    begin
	    If Ready then Error(7) else Num := N;
	    end;
	  Ready := TRUE;
	end;

	procedure AbsOp;
	var  N : trealnum;
	begin
	  If AbsOn then
	    Quit  := TRUE
	   else
	    begin
	    AbsOn := TRUE;
	    N := Compute(0, FALSE, succ(iter));
	    AbsOn := FALSE;
	    If (N < 0) then N := -N;
	    Punch(N);
	    end;
	end;

	procedure PushNum;
	var  A : string;
	     N : trealnum;
	     c : integer;
	begin
	  A := '';
	  If (S[x] in['+','-']) then
	    begin
	    If (S[x] = '-') then A := S[x];
	    inc(x);
	    end;
	  While (S[x] in['.','0'..'9']) and (x <= length(S)) and (E = 0) do
	    begin
	    If (S[x] = '.') and (pos('.',A) > 0) then Error(7);
	    A := A + S[x];
	    inc(x);
	    end;
	  dec(x);
	  Val(A,N,c);
	  If (c <> 0) and (E = 0) then Error(1);
	  If (E = 0) then Punch(N);
	end;

	procedure PushOp;
	begin
	  If Ready then Op := S[x] else Error(6);
	end;

	function  CalcFunc : trealnum;
	begin
	  Error(1);
	end;

    begin
      Op := #0;
      Ready := Func;
      Quit  := FALSE;
      While (x < length(S)) and (E = 0) and not Quit do
	begin
	inc(x);
	t1 := x;
	Case upcase(S[x]) of
	  '+','-':	If (Op = #0) and Ready then PushOp else PushNum;
	  '/','*','^':	PushOp;
	  '0'..'9','.':	PushNum;
	  '@':		Punch(CalcFunc);
	  '|':		AbsOp;
	  '(':		Punch(Compute(0, FALSE, succ(iter)));
	  ')':		Quit := TRUE;
	  '%':
	    begin
	    If Ready then Num := (Num / 100) else Error(6);
	    If Func then Quit := TRUE;
	    end;
	  'P':
	    If (upcase(S[succ(x)]) = 'I') and (length(S) > x) then
	      begin
	      inc(x);
	      Punch(Pi);
	      end;
	  #0,^I,' ':	begin end;
	 else		Error(1);
	  end;
	end;
      If (iter > 0) and not (S[x] in[')','|']) and not Func then Error(2);
      If (Op <> #0) then Error(3);
      Compute := Num;
    end;

begin
  E := 0;
  x := 0;
  code	:= 0;
  AbsOn := FALSE;
  If (S = '') then code := 1 else V := Compute(0, FALSE, 0);
end;


  {  }


procedure CurrentFieldWindow;
var  DMX      : PDmxEditor;
     FieldWin : PFieldWin;
begin
  DMX := Message(DeskTop, evCommand, cmDMX_RollCall, nil);
  If (DMX <> nil) then With DMX^ do
    If FieldSelected then
      begin
      Vidis := TRUE;
      New(FieldWin, Init('Edit', DMX));
      If (Application^.ValidView(FieldWin) <> nil) then
	begin
	DeskTop^.ExecView(FieldWin);
	Dispose(FieldWin, Done);
	end;
      EvaluateField;
      SetupField;
      Vidis := FALSE;
      end;
end;


  {  TEditField  }


constructor TEditField.Init(ADmx : PDmxEditor);
var  R : TRect;
begin
  R.Assign(1,1,24,2);
  TInputLine.Init(R, 255);
  DMX := ADmx;
end;


function  TEditField.Valid(Command : word) : boolean;
var  Vx : boolean;

    function  SetField : boolean;
    const  noeditstr = #0#0'noedit'#0#0;
    var  S : string;
	 w : integer;
	 l : longint;
    begin
      Case upcase(DMX^.CurrentField^.typecode) of
	fldSTR,fldSTRNUM:	S := pstring(DMX^.FieldData)^;
	fldCHAR,fldCHARNUM:
	  begin
	  S[0] := char(DMX^.CurrentField^.fieldsize);
	  Move(DMX^.FieldData^, S[1], length(S));
	  end;
	fldBYTE,
	fldENUM:	Str(pbyte(DMX^.FieldData)^:1, S);
	fldSHORTINT:	Str(pshortint(DMX^.FieldData)^:1, S);
	fldWORD:	Str(pword(DMX^.FieldData)^:1, S);
	fldINTEGER:	Str(pinteger(DMX^.FieldData)^:1, S);
	fldLONGINT:	Str(plongint(DMX^.FieldData)^:1, S);
	fldHEXVALUE:
	  If (DMX^.CurrentField^.fieldsize > 4) then
	    S := noeditstr
	   else
	    begin
	    L := 0;
	    Move(DMX^.FieldData^, L, DMX^.CurrentField^.fieldsize);
	    Str(L:1, S);
	    end;
	fldREALNUM:
	  If (prealnum(DMX^.FieldData)^ = Pi) then
	    S := 'Pi'
	   else
	    begin
	    w := DMX^.CurrentField^.decimals;
	    If (w < 7) then w := 7;
	    Str(prealnum(DMX^.FieldData)^:1:w, S);
	    While (S[length(S)] = '0') do Dec(S[0]);
	    If (S[length(S)] = '.') then Dec(S[0]);
	    end;
       else		S := noeditstr;
	end;
      If (S <> noeditstr) then
	begin
	SetData(S);
	SetField := TRUE;
	end
       else
	SetField := FALSE;
    end;

    function  GetField : boolean;
    var  S  : string;  code,len : integer;
	 L  : longint;
	 R  : trealnum;
	 OutOfRange : boolean;
	procedure Xfer(Min,Max : longint);
	begin
	  If not OutOfRange and (L >= Min) and (L <= Max) then
	    begin
	    Move(L, DMX^.FieldData^, DMX^.CurrentField^.fieldsize);
	    GetField := TRUE;
	    end
	   else  OutOfRange := TRUE;
	end;
    begin
      GetField	 := FALSE;
      OutOfRange := FALSE;
      GetData(S);
      If upcase(DMX^.CurrentField^.typecode) in[fldSTR,fldSTRNUM, fldCHAR,fldCHARNUM] then
	begin
	len := DMX^.CurrentField^.fieldsize;
	If (upcase(DMX^.CurrentField^.typecode) in[fldSTR,fldSTRNUM]) then
	  dec(len);
	While (S[length(S)] = ' ') and (length(S) > len) do Dec(S[0]);
	If (length(S) > len) then
	  begin
	  t1   := DMX^.CurrentField^.fieldsize;
	  code := length(S);
	  end
	 else
	  code := 0;
	R := 0;
	end
       else
	begin
	CalcVal(S,R,code);
	If (abs(R) > MaxLongInt) then OutOfRange := TRUE else L := round(R);
	end;
      If (code <> 0) then
	begin
	SelStart := pred(t1);
	CurPos	 := pred(t1);
	SelEnd	 := code;
	DrawView;
	OutOfRange := TRUE;
	end
       else
	begin
	Case upcase(DMX^.CurrentField^.typecode) of
	  fldSTR,fldSTRNUM:
	    begin
	    Move(S, DMX^.FieldData^, length(S) + 1);
	    GetField := TRUE;
	    end;
	  fldCHAR,fldCHARNUM:
	    begin
	    Move(S[1], DMX^.FieldData^, length(S));
	    GetField := TRUE;
	    end;
	  fldBYTE,
	  fldENUM:	Xfer(0, 255);
	  fldSHORTINT:	Xfer(-128, 127);
	  fldWORD:	Xfer(0, 65535);
	  fldINTEGER:	Xfer(-32768, 32767);
	  fldLONGINT:	Xfer(-2147483647, 2147483647);
	  fldHEXVALUE:
	    Case DMX^.CurrentField^.fieldsize of
	      1:  If (L >= 0) then Xfer(0, $FF) else Xfer(-128, 127);
	      2:  If (L >= 0) then Xfer(0, $FFFF) else Xfer(-32768, 32767);
	      3:  If (L >= 0) then Xfer(0, $FFFFFF) else Xfer(-16777216, 16777215);
	      4:  Xfer(-2147483647, 2147483647);
	      end;
	  fldREALNUM:
	    begin
	    Move(R, DMX^.FieldData^, DMX^.CurrentField^.fieldsize);
	    GetField := TRUE;
	    end;
	  end;
	end;
      If OutOfRange then
	Message(Application, evCommand, cmDMX_WrongKey, @Self);
    end;

begin
  Vx := TInputLine.Valid(Command);
  If (Command = cmValid) then
    begin
    If ((DMX = nil) or (DMX^.CurrentField = nil))
       or (not DMX^.FieldSelected) or not SetField then
      Vx := FALSE;
    end
   else
    If (Command = cmOK) and Vx then
      begin
      Vx := GetField;
      If Vx and (DMX <> nil) then
	begin
	DMX^.ChangeMade;
	DMX^.DrawView;
	end;
      end;
  Valid := Vx;
end;


  {  TFieldWin  }


constructor TFieldWin.Init(ATitle : TTitleStr; ADmx : PDmxEditor);
var  R : TRect;
     W : TDialog;
     x,y : integer;
begin
  If (ADmx <> nil) then
    begin
    With ADmx^ do
      begin
      R.A.X := CurrentField^.screentab - Delta.X - 1;
      R.A.Y := CurrentRecord - Delta.Y - 1;
      end;
    ADmx^.MakeGlobal(R.A, R.A);
    DeskTop^.MakeLocal(R.A, R.A);
    If (R.A.X < 0) then R.A.X := 0;
    If (R.A.Y < 0) then R.A.Y := 0;
    If (R.A.X + 25 > DeskTop^.Size.X) then R.A.X := DeskTop^.Size.X - 25;
    If (R.A.Y +  3 > DeskTop^.Size.Y) then R.A.Y := DeskTop^.Size.Y -  3;
    R.Assign(R.A.X, R.A.Y, R.A.X + 25, R.A.Y + 3);
    end
   else
    R.Assign(0,0,25,3);
  TDialog.Init(R, ATitle);
  Flags := Flags and not wfMove;
  Insert(New(PEditField, Init(ADmx)));
end;


procedure TFieldWin.HandleEvent(var Event : TEvent);
begin
  If (Event.What = evKeyDown) and (Event.KeyCode = kbEnter) then
    begin
    Event.What	  := evCommand;
    Event.Command := cmOK;
    end;
  TDialog.HandleEvent(Event);
end;


  {  }


End.
